' Requires references to:
'       Microsoft.DirectX
'       Microsoft.DirectX.Direct3D
Imports System.Windows.Forms
Imports Microsoft.DirectX
Imports Microsoft.DirectX.Direct3D

Module SubMain
    ' Build the form and display the graphics.
    Sub Main()
        System.Windows.Forms.Application.EnableVisualStyles()

        ' Make the form.
        Dim octahedron_form As New OctahedronForm()
        Using octahedron_form
            ' Initialize graphics.
            If Not octahedron_form.InitializeGraphics() Then
                MessageBox.Show("Error initializing Direct3D.", "Direct3D Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Return
            End If

            ' Display the form.
            octahedron_form.Show()

            ' While the form is valid, render the scene.
            While octahedron_form.Created
                octahedron_form.Render()
                Application.DoEvents()
            End While
        End Using
    End Sub
End Module
